Skip to main content
`Ctrl`+`K`

# `skopt.learning`.RandomForestRegressor

class skopt.learning.RandomForestRegressor(n_estimators=10, criterion='squared_error', max_depth=None, min_samples_split=2, min_samples_leaf=1, min_weight_fraction_leaf=0.0, max_features=None, max_leaf_nodes=None, min_impurity_decrease=0.0, bootstrap=True, oob_score=False, n_jobs=1, random_state=None, verbose=0, warm_start=False, min_variance=0.0)

  RandomForestRegressor that supports conditional std computation.

  Parameters:
    n_estimators integer, optional (default=10)

      The number of trees in the forest.

    criterion string, optional (default=”squared_error”)

      The function to measure the quality of a split. Supported criteria are “squared_error” for the mean squared error, which is equal to variance reduction as feature selection criterion, and “mae” for the mean absolute error.

    max_features int, float, string or None, optional (default=”auto”)

      The number of features to consider when looking for the best split:

      - If int, then consider `max_features` features at each split.

      - If float, then `max_features` is a percentage and `int(max_features * n_features)` features are considered at each split.

      - If “auto”, then `max_features=n_features`.

      - If “sqrt”, then `max_features=sqrt(n_features)`.

      - If “log2”, then `max_features=log2(n_features)`.

      - If None, then `max_features=n_features`.

      Note

      The search for a split does not stop until at least one valid partition of the node samples is found, even if it requires to effectively inspect more than `max_features` features.

    max_depth integer or None, optional (default=None)

      The maximum depth of the tree. If None, then nodes are expanded until all leaves are pure or until all leaves contain less than min_samples_split samples.

    min_samples_split int, float, optional (default=2)

      The minimum number of samples required to split an internal node:

      - If int, then consider `min_samples_split` as the minimum number.

      - If float, then `min_samples_split` is a percentage and `ceil(min_samples_split * n_samples)` are the minimum number of samples for each split.

    min_samples_leaf int, float, optional (default=1)

      The minimum number of samples required to be at a leaf node:

      - If int, then consider `min_samples_leaf` as the minimum number.

      - If float, then `min_samples_leaf` is a percentage and `ceil(min_samples_leaf * n_samples)` are the minimum number of samples for each node.

    min_weight_fraction_leaf float, optional (default=0.)

      The minimum weighted fraction of the sum total of weights (of all the input samples) required to be at a leaf node. Samples have equal weight when sample_weight is not provided.

    max_leaf_nodes int or None, optional (default=None)

      Grow trees with `max_leaf_nodes` in best-first fashion. Best nodes are defined as relative reduction in impurity. If None then unlimited number of leaf nodes.

    min_impurity_decrease float, optional (default=0.)

      A node will be split if this split induces a decrease of the impurity greater than or equal to this value. The weighted impurity decrease equation is the following:

          N_t / N * (impurity - N_t_R / N_t * right_impurity
                              - N_t_L / N_t * left_impurity)

      where `N` is the total number of samples, `N_t` is the number of samples at the current node, `N_t_L` is the number of samples in the left child, and `N_t_R` is the number of samples in the right child. `N`, `N_t`, `N_t_R` and `N_t_L` all refer to the weighted sum, if `sample_weight` is passed.

    bootstrap boolean, optional (default=True)

      Whether bootstrap samples are used when building trees.

    oob_score bool, optional (default=False)

      whether to use out-of-bag samples to estimate the R^2 on unseen data.

    n_jobs integer, optional (default=1)

      The number of jobs to run in parallel for both `fit` and `predict`. If -1, then the number of jobs is set to the number of cores.

    random_state int, RandomState instance or None, optional (default=None)

      If int, random_state is the seed used by the random number generator; If RandomState instance, random_state is the random number generator; If None, the random number generator is the RandomState instance used by `np.random`.

    verbose int, optional (default=0)

      Controls the verbosity of the tree building process.

    warm_start bool, optional (default=False)

      When set to `True`, reuse the solution of the previous call to fit and add more estimators to the ensemble, otherwise, just fit a whole new forest.

  Attributes:
    estimators_list of DecisionTreeRegressor

      The collection of fitted sub-estimators.

    `feature_importances_`array of shape = [n_features]

      The impurity-based feature importances.

    n_features_int

      The number of features when `fit` is performed.

    n_outputs_int

      The number of outputs when `fit` is performed.

    oob_score_float

      Score of the training dataset obtained using an out-of-bag estimate.

    oob_prediction_array of shape = [n_samples]

      Prediction computed with out-of-bag estimate on the training set.

  Notes

  The default values for the parameters controlling the size of the trees (e.g. `max_depth`, `min_samples_leaf`, etc.) lead to fully grown and unpruned trees which can potentially be very large on some data sets. To reduce memory consumption, the complexity and size of the trees should be controlled by setting those parameter values. The features are always randomly permuted at each split. Therefore, the best found split may vary, even with the same training data, `max_features=n_features` and `bootstrap=False`, if the improvement of the criterion is identical for several splits enumerated during the search of the best split. To obtain a deterministic behaviour during fitting, `random_state` has to be fixed.

  References

  [1]

  12. Breiman, “Random Forests”, Machine Learning, 45(1), 5-32, 2001.

  Methods

  `apply`(X) | Apply trees in the forest to X, return leaf indices.
  `decision_path`(X) | Return the decision path in the forest.
  `fit`(X, y[, sample_weight]) | Build a forest of trees from the training set (X, y).
  `get_metadata_routing`() | Get metadata routing of this object.
  `get_params`([deep]) | Get parameters for this estimator.
  `predict`(X[, return_std]) | Predict continuous output for X.
  `score`(X, y[, sample_weight]) | Return coefficient of determination on test data.
  `set_fit_request`(*[, sample_weight]) | Configure whether metadata should be requested to be passed to the `fit` method.
  `set_params`(**params) | Set the parameters of this estimator.
  `set_predict_request`(*[, return_std]) | Configure whether metadata should be requested to be passed to the `predict` method.
  `set_score_request`(*[, sample_weight]) | Configure whether metadata should be requested to be passed to the `score` method.

  __init__(n_estimators=10, criterion='squared_error', max_depth=None, min_samples_split=2, min_samples_leaf=1, min_weight_fraction_leaf=0.0, max_features=None, max_leaf_nodes=None, min_impurity_decrease=0.0, bootstrap=True, oob_score=False, n_jobs=1, random_state=None, verbose=0, warm_start=False, min_variance=0.0)
  apply(X)

    Apply trees in the forest to X, return leaf indices.

    Parameters:
      X{array-like, sparse matrix} of shape (n_samples, n_features)

        The input samples. Internally, its dtype will be converted to `dtype=np.float32`. If a sparse matrix is provided, it will be converted into a sparse `csr_matrix`.

    Returns:
      X_leaves ndarray of shape (n_samples, n_estimators)

        For each datapoint x in X and for each tree in the forest, return the index of the leaf x ends up in.

  decision_path(X)

    Return the decision path in the forest.

    Added in version 0.18.

    Parameters:
      X{array-like, sparse matrix} of shape (n_samples, n_features)

        The input samples. Internally, its dtype will be converted to `dtype=np.float32`. If a sparse matrix is provided, it will be converted into a sparse `csr_matrix`.

    Returns:
      indicator sparse matrix of shape (n_samples, n_nodes)

        Return a node indicator matrix where non zero elements indicates that the samples goes through the nodes. The matrix is of CSR format.

      n_nodes_ptr ndarray of shape (n_estimators + 1,)

        The columns from indicator[n_nodes_ptr[i]:n_nodes_ptr[i+1]] gives the indicator value for the i-th estimator.

  property estimators_samples_

    The subset of drawn samples for each base estimator.

    Returns a dynamically generated list of indices identifying the samples used for fitting each member of the ensemble, i.e., the in-bag samples.

    Note: the list is re-created at each call to the property in order to reduce the object memory footprint by not storing the sampling data. Thus fetching the property may be slower than expected.

  property feature_importances_

    The impurity-based feature importances.

    The higher, the more important the feature. The importance of a feature is computed as the (normalized) total reduction of the criterion brought by that feature. It is also known as the Gini importance.

    Warning: impurity-based feature importances can be misleading for high cardinality features (many unique values). See `sklearn.inspection.permutation_importance()` as an alternative.

    Returns:
      feature_importances_ndarray of shape (n_features,)

        The values of this array sum to 1, unless all trees are single node trees consisting of only the root node, in which case it will be an array of zeros.

  fit(X, y, sample_weight=None)

    Build a forest of trees from the training set (X, y).

    Parameters:
      X{array-like, sparse matrix} of shape (n_samples, n_features)

        The training input samples. Internally, its dtype will be converted to `dtype=np.float32`. If a sparse matrix is provided, it will be converted into a sparse `csc_matrix`.

      y array-like of shape (n_samples,) or (n_samples, n_outputs)

        The target values (class labels in classification, real numbers in regression).

      sample_weight array-like of shape (n_samples,), default=None

        Sample weights. If None, then samples are equally weighted. Splits that would create child nodes with net zero or negative weight are ignored while searching for a split in each node. In the case of classification, splits are also ignored if they would result in any single class carrying a negative weight in either child node.

    Returns:
      self object

        Fitted estimator.

  get_metadata_routing()

    Get metadata routing of this object.

    Please check User Guide on how the routing mechanism works.

    Returns:
      routing MetadataRequest

        A `MetadataRequest` encapsulating routing information.

  get_params(deep=True)

    Get parameters for this estimator.

    Parameters:
      deep bool, default=True

        If True, will return the parameters for this estimator and contained subobjects that are estimators.

    Returns:
      params dict

        Parameter names mapped to their values.

  predict(X, return_std=False)

    Predict continuous output for X.

    Parameters:
      X array of shape = (n_samples, n_features)

        Input data.

      return_std boolean

        Whether or not to return the standard deviation.

    Returns:
      predictions array-like of shape = (n_samples,)

        Predicted values for X. If criterion is set to “squared_error”, then `predictions[i] ~= mean(y | X[i])`.

      std array-like of shape=(n_samples,)

        Standard deviation of `y` at `X`. If criterion is set to “squared_error”, then `std[i] ~= std(y | X[i])`.

  score(X, y, sample_weight=None)

    Return coefficient of determination on test data.

    The coefficient of determination, \(R^2\), is defined as \((1 - \frac{u}{v})\), where \(u\) is the residual sum of squares `((y_true - y_pred)** 2).sum()` and \(v\) is the total sum of squares `((y_true - y_true.mean()) ** 2).sum()`. The best possible score is 1.0 and it can be negative (because the model can be arbitrarily worse). A constant model that always predicts the expected value of `y`, disregarding the input features, would get a \(R^2\) score of 0.0.

    Parameters:
      X array-like of shape (n_samples, n_features)

        Test samples. For some estimators this may be a precomputed kernel matrix or a list of generic objects instead with shape `(n_samples, n_samples_fitted)`, where `n_samples_fitted` is the number of samples used in the fitting for the estimator.

      y array-like of shape (n_samples,) or (n_samples, n_outputs)

        True values for `X`.

      sample_weight array-like of shape (n_samples,), default=None

        Sample weights.

    Returns:
      score float

        \(R^2\) of `self.predict(X)` w.r.t. `y`.

    Notes

    The \(R^2\) score used when calling `score` on a regressor uses `multioutput='uniform_average'` from version 0.23 to keep consistent with default value of `r2_score()`. This influences the `score` method of all the multioutput regressors (except for `MultiOutputRegressor`).

  set_fit_request(*, sample_weight: bool | None | str = '$UNCHANGED$') → RandomForestRegressor

    Configure whether metadata should be requested to be passed to the `fit` method.

    Note that this method is only relevant when this estimator is used as a sub-estimator within a meta-estimator and metadata routing is enabled with `enable_metadata_routing=True` (see `sklearn.set_config()`). Please check the User Guide on how the routing mechanism works.

    The options for each parameter are:

    - `True`: metadata is requested, and passed to `fit` if provided. The request is ignored if metadata is not provided.

    - `False`: metadata is not requested and the meta-estimator will not pass it to `fit`.

    - `None`: metadata is not requested, and the meta-estimator will raise an error if the user provides it.

    - `str`: metadata should be passed to the meta-estimator with this given alias instead of the original name.

    The default (`sklearn.utils.metadata_routing.UNCHANGED`) retains the existing request. This allows you to change the request for some parameters and not others.

    Added in version 1.3.

    Parameters:
      sample_weight str, True, False, or None, default=sklearn.utils.metadata_routing.UNCHANGED

        Metadata routing for `sample_weight` parameter in `fit`.

    Returns:
      self object

        The updated object.

  set_params(**params)

    Set the parameters of this estimator.

    The method works on simple estimators as well as on nested objects (such as `Pipeline`). The latter have parameters of the form `<component>__<parameter>` so that it’s possible to update each component of a nested object.

    Parameters:
      **params dict

        Estimator parameters.

    Returns:
      self estimator instance

        Estimator instance.

  set_predict_request(*, return_std: bool | None | str = '$UNCHANGED$') → RandomForestRegressor

    Configure whether metadata should be requested to be passed to the `predict` method.

    Note that this method is only relevant when this estimator is used as a sub-estimator within a meta-estimator and metadata routing is enabled with `enable_metadata_routing=True` (see `sklearn.set_config()`). Please check the User Guide on how the routing mechanism works.

    The options for each parameter are:

    - `True`: metadata is requested, and passed to `predict` if provided. The request is ignored if metadata is not provided.

    - `False`: metadata is not requested and the meta-estimator will not pass it to `predict`.

    - `None`: metadata is not requested, and the meta-estimator will raise an error if the user provides it.

    - `str`: metadata should be passed to the meta-estimator with this given alias instead of the original name.

    The default (`sklearn.utils.metadata_routing.UNCHANGED`) retains the existing request. This allows you to change the request for some parameters and not others.

    Added in version 1.3.

    Parameters:
      return_std str, True, False, or None, default=sklearn.utils.metadata_routing.UNCHANGED

        Metadata routing for `return_std` parameter in `predict`.

    Returns:
      self object

        The updated object.

  set_score_request(*, sample_weight: bool | None | str = '$UNCHANGED$') → RandomForestRegressor

    Configure whether metadata should be requested to be passed to the `score` method.

    Note that this method is only relevant when this estimator is used as a sub-estimator within a meta-estimator and metadata routing is enabled with `enable_metadata_routing=True` (see `sklearn.set_config()`). Please check the User Guide on how the routing mechanism works.

    The options for each parameter are:

    - `True`: metadata is requested, and passed to `score` if provided. The request is ignored if metadata is not provided.

    - `False`: metadata is not requested and the meta-estimator will not pass it to `score`.

    - `None`: metadata is not requested, and the meta-estimator will raise an error if the user provides it.

    - `str`: metadata should be passed to the meta-estimator with this given alias instead of the original name.

    The default (`sklearn.utils.metadata_routing.UNCHANGED`) retains the existing request. This allows you to change the request for some parameters and not others.

    Added in version 1.3.

    Parameters:
      sample_weight str, True, False, or None, default=sklearn.utils.metadata_routing.UNCHANGED

        Metadata routing for `sample_weight` parameter in `score`.

    Returns:
      self object

        The updated object.